import java.io.*;
import java.text.*; // for DecimalFormat


public class Decision { 


    private double[] chi2;
    private int[]    ndf;
    private double[][]   pSoFar;
    private String sum;
    private static DecimalFormat df = new DecimalFormat("#.####");
    private String stime;
    private String type;
 
    Decision(String type, double[] chi2, int[] ndf, double[][] pSoFar,  String file, String stime) {

    this.type=type; 
    this.chi2=chi2;
    this.ndf=ndf;
    this.pSoFar=pSoFar;
    this.stime=stime;

    sum=summary(); 


              String sfile=file+".d";
              System.out.println("Write data file to="+sfile);


              try {
              FileWriter fw = new FileWriter(sfile);
              BufferedWriter bw = new BufferedWriter(fw);

              bw.write("# image="+file+"  time(sec)="+stime+"\n");
              bw.write(sum+"\n");

              for (int i=0; i<chi2.length; i++) {
              bw.write("chi2["+i+"] ="+df.format(chi2[i]));
              bw.write("  ndf["+i+"] ="+df.format(ndf[i]));
              bw.write("  chi2/ndf["+i+"] ="+df.format( chi2ndf(chi2[i],ndf[i]) )
                          +"\n");

              }

              bw.write("\nchi2/ndf evolution:\n");
              for (int i=0; i<pSoFar.length; i++) {
                for (int j=0; j<pSoFar[0].length; j++) bw.write("  "+df.format(  pSoFar[i][j] ));
                bw.write("\n"); 
              }

               bw.close();


             } catch(Exception e) {
               System.out.println("Exception: " + e);
              }
 
               // summary
               System.out.println(sum);

    }













    public String summary() {


    String similar="Not fully identical. Derived from the original image.";

    String tmp="\nSUMMARY:\n";

    tmp +="========\n";
 
    double[] x = new double [chi2.length];
    for (int i=0; i<chi2.length; i++) x[i]=chi2ndf(chi2[i],ndf[i]); // prob(chi2[i],ndf[i]);

    tmp += "\n";
    tmp += "# Estimated color  similarity="+df.format( x[0] );
    tmp += "\n";
    tmp += "# Estimated object XY similarity="+df.format( x[1] );
    tmp += "\n";
    tmp += "# Estimated object COL similarity="+df.format( x[2] );
    tmp += "\n";
    tmp += "# Estimated avr   XY similarity="+df.format( x[3] );
    tmp += "\n";
    tmp += "# Estimated avr   COL similarity="+df.format( x[4] );
    tmp += "\n";

    tmp += "\nCONCLUSION:  Decision time="+stime+"(s). ";



    if (type.equals("plot")) {


    if (x[0]<0.0001 && x[1]<0.05 ) {tmp += " Identical\n";
                                            return tmp; }

    if (x[1]<1 ) {tmp += " Objects  are very similar (color added, transformed?)";
                                            tmp += " 95%\n"; 
                                            return tmp; }

    if (x[1]<2 ) {tmp += " Objects are  similar (color added, transformed?)";
                                            tmp += " 90%\n";
                                             return tmp; }
    
    if (x[1]<3 && x[0]<5 ) {tmp += " Objects are similar.";
                                            tmp += " 70%\n";
                                            return tmp; }

     
    if (x[1]<3 && x[0]>20 ) {tmp += " Objects are very different.";
                                            tmp += " 10%\n";
                                            return tmp; }

    
    if (x[1]<3 && x[0]>10 ) {tmp += " Objects are rather different.";
                                            tmp += " 30%\n";
                                            return tmp; }

    if (x[1]<3 && x[0]>5 ) {tmp += " Objects are rather different.";
                                            tmp += " 50%\n";
                                            return tmp; }


     if (x[1]<4 &&  x[0]<5) {tmp += " Objects are  added or transformed.";
                                            tmp += " 70%\n"; 
                                            return tmp; }

     if (x[1]<4 &&  x[0]>20) {tmp += " Objects are are different.";
                                            tmp += " 30%\n";
                                            return tmp; }

     if (x[1]<4 &&  x[0]>10) {tmp += " Objects are are different.";
                                            tmp += " 50%\n";
                                            return tmp; }

    if (x[1]<4 &&  x[0]>5) {tmp += " Objects are are different.";
                                            tmp += " 70%\n";
                                            return tmp; }

      
     if (x[1]>4 && x[3]>10  ) {tmp += " Objects are very different";
                                       tmp += " 10%\n";
                                       return tmp; }

     if (x[1]>4 && x[3]>5  ) {tmp += " Objects are different";
                                       tmp += " 50%\n";
                                       return tmp; }

     if (ndf[1]>1 && pSoFar[1][2]>5 && pSoFar[1][3]>5) {tmp += " Objects are different\n";
                                                                     return tmp; }

     if (x[0]>3 && x[1]<3 && x[3]<3  ) {tmp += " Objects are similar, colors are different\n";
                                       return tmp; }

     if (x[1]>4) {tmp += " Objects are rather different.";
                                            tmp += " 50%\n";
                                            return tmp; }

    } 


// else is for photo










    if (x[0]<0.0001 && x[1]<0.5 ) {tmp += " Identical\n";
                                            return tmp; }

   
 
   if (ndf[1]>1 && pSoFar[1][2]>5 && pSoFar[1][3]>5 && x[0]>5) {tmp += " No similarity. Type 1\n";
                                                                     return tmp; }

   else if (x[0]>5 && x[1]>5 && x[2]>20 && pSoFar[1][2]>5 && pSoFar[1][3]>5 ) {
                                                        tmp += " No similarity. Type 2\n";
                                                                     return tmp; }
   else if (x[0]>5 && x[1]>1 && x[2]>100 && x[3]>100 ) {tmp += " No similarity. Type 3\n";
                                                                     return tmp; }

   else if (x[0]>3 && x[1]>7 && x[2]>1000 && x[3]>7 && x[3]>1000 ) {tmp += " No similarity. Type 4\n";
                                                                     return tmp; }

   else if (x[0]>7 && x[1]>1 && x[2]>5) {tmp += " No similarity. Type 5\n";
                                                                     return tmp; }

   else if (x[0]>3 && x[1]>1 && x[2]>50 && x[3]>50 && x[3]>50 ) {tmp += " No similarity. Type 6\n";
                                                                     return tmp; }


 
   else if (x[0]<1  && x[1]<3) {tmp += similar; tmp += " 95%";  
                                return tmp;} 
   
   else if (x[0]<2  && x[1]<4) {tmp += similar; tmp += " 90%";
                                return tmp;}
 
   else if (x[0]<3  && x[1]<5) {tmp += similar; tmp += " 85%"; 
                                return tmp;}

   else if (x[0]<5  && x[1]<5) {tmp += similar; tmp += " 80%";
                                return tmp;}

   else if (x[0]<5  && x[1]<10 && x[2]<5 &&  x[3]<5 ) {tmp += similar; tmp += " 70%";
                                    return tmp;}

   else if (ndf[1]>1 && pSoFar[1][2]<5 && pSoFar[1][3]<5 && x[0]<5 && x[1]>5) {
                           tmp +=  similar;
                           tmp += " 60%";
                           return tmp;}
   else if (ndf[1]>1 && pSoFar[1][2]<5 && pSoFar[1][3]<6 && x[0]<5) {
                           tmp +=  similar;
                           tmp += " 50%";
                           return tmp;}
   else if (ndf[1]>1 && pSoFar[1][2]<5 && pSoFar[1][3]<6 && x[0]<6) {
                           tmp +=  similar;
                           tmp += " 30%";
                           return tmp;}
   else if (x[0]>6) {
                           tmp +=  " No similarity. Type 5";
                           return tmp;}



   else {
           tmp +=   "Unknown type";
           tmp += " <30%";
           }


   return tmp; 

   }


  /**
  * get measure of difference
  */
 public double prob(double xchi2, int xndf) {

    double c= -999.0; 
    if (xndf>0) c=Math.sqrt(xchi2)/ xndf;
    c= 1.0/Math.exp(c);

    // double p=StatTools.chi2Df(chi2,ndf);
    // double p=math.Probability.chiSquare(ndf, chi2);

    return c;
 }


/**
  * get measure of difference
  */
 public static double chi2ndf(double xchi2, int xndf) {

    double c= -999.0;
    if (xndf>0) c=xchi2/ xndf;
    return c;
 }





  public static void print(double[] xchi2, int[] xndf) {


     for (int i=0; i<xchi2.length; i++) {
     // System.out.print("chi2["+i+"] ="+ df.format( xchi2[i] ) );
     // System.out.print("  ndf["+i+"] ="+ df.format( xndf[i] ) );
     System.out.println("  chi2/ndf["+i+"] ="+df.format( chi2ndf(xchi2[i],xndf[i])));
     }

 }

}
