/*
 * Created on May 22, 2005
 * @author Rafael Santos (rafael.santos@lac.inpe.br)
 * 
 * Part of the Java Advanced Imaging Stuff site
 * (http://www.lac.inpe.br/~rafael.santos/Java/JAI)
 * 
 * STATUS: Complete.
 * 
 * Redistribution and usage conditions must be done under the
 * Creative Commons license:
 * English: http://creativecommons.org/licenses/by-nc-sa/2.0/br/deed.en
 * Portuguese: http://creativecommons.org/licenses/by-nc-sa/2.0/br/deed.pt
 * More information on design and applications are on the projects' page
 * (http://www.lac.inpe.br/~rafael.santos/Java/JAI).
 */
package operators;

import javax.media.jai.JAI;
import javax.media.jai.PlanarImage;

/**
 * This class demonstrates the use of the bandselect operator.
 */
public class BandSelect
  {
 /**
  * The application entry point.
  * @param args the command line arguments. The first argument is the
  * name of the image, the second is the band number (starting with zero)
  * and the third argument, the name of the output image.
  */
  public static void main(String[] args)
    {
    // We need exactly three arguments.
    if (args.length != 3)
      {
      System.err.println("Usage: java operators.BandSelect inputImage "+
                         "band outputImage");
      System.exit(0);
      }
    // Read the input image.
    PlanarImage input = JAI.create("fileload", args[0]);
    // Get the desired band index.
    int index = Integer.parseInt(args[1]);
    // Create an output image via the bandselect operator.
    PlanarImage output = JAI.create("bandselect",input,new int[] {index});
    // Store it as a TIFF.
    JAI.create("filestore",output,args[2],"TIFF");
    }
   
  } // end class