/*
 * Created on Jun 16, 2005
 * @author Rafael Santos (rafael.santos@lac.inpe.br)
 * 
 * Part of the Java Advanced Imaging Stuff site
 * (http://www.lac.inpe.br/~rafael.santos/Java/JAI)
 * 
 * STATUS: Complete.
 * 
 * Redistribution and usage conditions must be done under the
 * Creative Commons license:
 * English: http://creativecommons.org/licenses/by-nc-sa/2.0/br/deed.en
 * Portuguese: http://creativecommons.org/licenses/by-nc-sa/2.0/br/deed.pt
 * More information on design and applications are on the projects' page
 * (http://www.lac.inpe.br/~rafael.santos/Java/JAI).
 */
package operators;

import java.awt.image.renderable.ParameterBlock;
import javax.media.jai.JAI;
import javax.media.jai.PlanarImage;
import javax.media.jai.RenderedOp;

/**
 * This class demonstrates the usage of the extrema operator.
 */
public class Extrema
  {
  /**
   * The application's entry point.
   * @param args the command-line arguments.
   */
  public static void main(String[] args)
    {
    // We need one arguments: the image file name.
    if (args.length != 1)
      {
      System.err.println("Usage: java operators.Lookup image");
      System.exit(0);
      }
    // Read the input image.
    PlanarImage image = JAI.create("fileload", args[0]);
    // Create a parameter block for extraction of the extrema.
    ParameterBlock pbMaxMin = new ParameterBlock();
    pbMaxMin.addSource(image);
    RenderedOp extremaOp = JAI.create("extrema", pbMaxMin);
    // Get the extrema of all bands !
    double[] allMins = (double[])extremaOp.getProperty("minimum");
    double[] allMaxs = (double[])extremaOp.getProperty("maximum");
    for(int b=0;b<allMins.length;b++)
      System.out.println("Band "+b+" values are between "+allMins[b]+" and "+allMaxs[b]);
    }

  }